package com.bryan.host;

import java.io.File;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import dalvik.system.DexClassLoader;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.res.AssetManager;
import android.content.res.Resources;
import android.content.res.Resources.Theme;
import android.os.Bundle;
import android.provider.MediaStore.Video;

public class ProxyActivity extends Activity
{
	/* mainActivity*/
	protected String mExtraClass;  
	protected String mExtraDexPath;
    
    /* classloderobject*/
	protected Class<?> mlocaClass;
	protected Object mobject; 
    
    /* Դ*/
    protected AssetManager mAssetManager;
    protected Resources mResources = null;
    protected Theme mTheme = null;
    
	@Override
	protected void onCreate(Bundle savedInstanceState) 
	{
		super.onCreate(savedInstanceState);
		
		mExtraClass = getIntent().getStringExtra("ExtraClass");
		mExtraDexPath = getIntent().getStringExtra("ExtraDexPath");
		
		if (mExtraClass == null) 
		{
			OpenDefaultActivity();
		}
		else
		{
			OpenAppointActivity(mExtraClass);
		}		
	}
	
	/* زactivity*/
	protected void OpenDefaultActivity()
	{
		PackageInfo packageInfo = getPackageManager().getPackageArchiveInfo(mExtraDexPath, PackageManager.GET_ACTIVITIES);
		if ((packageInfo.activities != null) && (packageInfo.activities.length >0)) 
		{
			mExtraClass = packageInfo.activities[0].name;
			OpenAppointActivity(mExtraClass);
		}
	}
	
	/* زָactivity*/
	@SuppressLint("NewApi") protected void OpenAppointActivity(final String className)
	{
		File dexOutputDir = this.getDir("dex", 0);  
	    final String dexOutputPath = dexOutputDir.getAbsolutePath();  
	    
	    DexClassLoader dexClassLoader = new DexClassLoader(mExtraDexPath, dexOutputPath, null,  ClassLoader.getSystemClassLoader() );
	    
	    try 
	    {
	    	loadResources();
	    	mlocaClass = dexClassLoader.loadClass(className);
			Constructor<?> localConstructor = mlocaClass.getConstructor(new Class[]{});
			mobject = localConstructor.newInstance(new Object[]{});
			
			/*  òеô */
			Method setProxy = mlocaClass.getMethod("setProxy", new Class[] {Activity.class});
			setProxy.setAccessible(true);
			setProxy.invoke(mobject, new Object[]{this});
			/* ߲Ǳ*/
			Method onCreate = mlocaClass.getDeclaredMethod("onCreate", new Class[] {Bundle.class});
			onCreate.setAccessible(true);
			Bundle bundle = new Bundle();  
            bundle.putInt("Host", 1);  
			onCreate.invoke(mobject, new Object[]{bundle});
			
		} catch (Exception e) 
		{
			e.printStackTrace();  
		}
	}
	
	
	protected void loadResources()
	{
		try 
		{
			AssetManager assetManager = AssetManager.class.newInstance();
			Method addAssetPath = assetManager.getClass().getMethod("addAssetPath", String.class);
			addAssetPath.invoke(assetManager, mExtraDexPath);
			mAssetManager = assetManager;	
		} catch (Exception e) {
			e.printStackTrace();
		}
		Resources superResources = super.getResources();
		mResources = new Resources(mAssetManager, superResources.getDisplayMetrics(), superResources.getConfiguration());
		mTheme = mResources.newTheme();
		mTheme.setTo(super.getTheme());
	}	
	
	/* дԴĺ */
	@Override  
	public AssetManager getAssets() 
	{
		if (mAssetManager != null) 
		{
			return mAssetManager;
		}
		return super.getAssets();
	}  
	  
	@Override  
	public Resources getResources() {  
		if (mResources != null) 
		{
			return mResources;			
		}
		return super.getResources();
	}

	
	/* ں */
	@Override
	protected void onStart() {
		super.onStart();
		ReflectOnFunction("onStart");		
	}

	@Override
	protected void onResume() {		
		super.onResume();	
		ReflectOnFunction("onResume");	
	}

	@Override
	protected void onPause() {
		super.onPause();
		ReflectOnFunction("onPause");	
	}

	@Override
	protected void onStop() {		
		super.onStop();
		ReflectOnFunction("onStop");	
	}

	@Override
	protected void onDestroy() {		
		super.onDestroy();
		ReflectOnFunction("onDestroy");	
	}  
	
	private void ReflectOnFunction(String FunctionName)
	{
		Method onFunction;
		try 
		{
			onFunction = mlocaClass.getDeclaredMethod(FunctionName, new Class[] {});
			onFunction.setAccessible(true);		
			onFunction.invoke(mobject);      
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}
	}
}
