package com.bryan.plugin;


import android.app.Activity;
import android.content.Intent;
import android.content.res.AssetManager;
import android.content.res.Resources;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup.LayoutParams;

public class BaseActivity extends Activity
{
	/* еĴActivity*/
	protected Activity mProxyActivity;
	
	/* жǱ˭ģΪ1 */
	int Who = 0;
	
	public void setProxy(Activity proxyActivity)
	{
		mProxyActivity = proxyActivity;
	}

	
	@Override
	protected void onCreate(Bundle savedInstanceState) 
	{
		if (savedInstanceState != null) 
		{
			Who = savedInstanceState.getInt("Host", 0);
		}
		if (Who == 0) 
		{
			super.onCreate(savedInstanceState);
			mProxyActivity = this;
		}
	}
	
	
	protected void StartActivityByProxy(String className)
	{
		if (mProxyActivity == this) 
		{
			Intent intent = new Intent();
			intent.setClassName(this, className);
			this.startActivity(intent);
		}
		else 
		{
			Intent intent = new Intent();
			intent.setAction("android.intent.action.ProxyVIEW");
			intent.putExtra("ExtraDexPath", "/mnt/sdcard/plugin.apk");
			intent.putExtra("ExtraClass", className);
			mProxyActivity.startActivity(intent);
		}
	}

	
	/* дҪӲֵ */
	
	@Override
	public void setContentView(View view) 
	{
		if (mProxyActivity == this) 
		{
			super.setContentView(view);
		}
		else
		{
			mProxyActivity.setContentView(view);
		}	
	}


	@Override
	public void addContentView(View view, LayoutParams params) 
	{
		if (mProxyActivity == this) 
		{
			super.addContentView(view, params);
		}
		else 
		{
			mProxyActivity.addContentView(view, params);
		}
		
	}


	@Override
	public void setContentView(int layoutResID) 
	{
		if (mProxyActivity == this) 
		{
			super.setContentView(layoutResID);
		}
		else 
		{
			mProxyActivity.setContentView(layoutResID);
		}
		
	}
	
	


	@Override
	public View findViewById(int id) {
		if (mProxyActivity == this) 
		{
			return super.findViewById(id);
		}
		else 
		{
			return mProxyActivity.findViewById(id);
		}		
	}


	@Override
	public void setContentView(View view, LayoutParams params) 
	{
		if (mProxyActivity == this) 
		{
			super.setContentView(view, params);
		}
		else 
		{
			mProxyActivity.setContentView(view, params);
		}
	}


	/* дԴķ  */
	@Override
	public Resources getResources() {
		if (Who == 0) 
		{
			return super.getResources();	
		}
		else 
		{
			PluginLog.pluginLog("mProxyActivity.getResources()");
			return mProxyActivity.getResources();
		}
	}
	
	
	@Override
	public AssetManager getAssets() {
		if (Who == 0) 
		{
			return super.getAssets();
		}
		else 
		{
			return mProxyActivity.getAssets();
		}	
	}
	
	
	/* дں */
	@Override
	protected void onStart() 
	{
		if (mProxyActivity == this) 
		{
			super.onStart();
			PluginLog.pluginLog("super on start log"); 
		}
		else {
			PluginLog.pluginLog(" onStart"); 
		}	
	}


	@Override
	protected void onResume() {
		if (mProxyActivity == this) 
		super.onResume();
	}


	@Override
	protected void onPause() {
		if (mProxyActivity == this) 
		super.onPause();
	}


	@Override
	protected void onStop() {
		if (mProxyActivity == this) 
		super.onStop();
	}


	@Override
	protected void onDestroy() {
		if (mProxyActivity == this) 
		super.onDestroy();
	}
	
	

	
}
