package com.bryan.plugin;

import android.content.Context;
import android.graphics.Color;
import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup.LayoutParams;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;

public class MainActivity extends BaseActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //setContentView(R.layout.activity_main);
        
        // ʼ
        InitView();
    }
    
    private void InitView()
    {
    	View view = CreateView(mProxyActivity); 
    	mProxyActivity.setContentView(view);
    	
    	System.out.println("MainActivity.InitView()" + "activity name is :"+mProxyActivity.getClass().getSimpleName());
    }
    
    private View CreateView(final Context context)
    {
    	LinearLayout linearLayout = new LinearLayout(context);
    	
    	linearLayout.setLayoutParams(new LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT));
    	linearLayout.setBackgroundColor(Color.parseColor("#F4F4D6"));    	
    	Button button = new Button(context);  
        button.setText("plugin button");  
        linearLayout.addView(button, LayoutParams.WRAP_CONTENT,LayoutParams.WRAP_CONTENT); 
        ImageView image = new ImageView(context);
        PluginLog.pluginLog("chuaԴ");
        image.setImageBitmap(new BitmapDrawable( getResources().openRawResource(R.drawable.qq)).getBitmap());
        linearLayout.addView(image, LayoutParams.WRAP_CONTENT,LayoutParams.WRAP_CONTENT); 
        button.setOnClickListener(new OnClickListener() {			
			@Override
			public void onClick(View v) {
				StartActivityByProxy("com.bryan.plugin.TestActivity");
			}
		});
    	return linearLayout;	
    }

    
	@Override
	protected void onStart() {
		super.onStart();
		PluginLog.pluginLog("onStart"); 
	}

	@Override
	protected void onPause() {
		super.onPause();	
		PluginLog.pluginLog("onPause"); 
	}

	@Override
	protected void onResume() {
		super.onResume();
		PluginLog.pluginLog("onResume"); 
	}

	@Override
	protected void onStop() {
		super.onStop();
		PluginLog.pluginLog("onStop"); 
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		PluginLog.pluginLog("onDestroy"); 
	}
	
	
    
    
    
}
